#!/usr/bin/env perl
use SynBlast::MyUtils;
#################################################################################
# combineTxtAlns.pl: 
# sorting text results of several syntenyAlignment output (e.g. different paralog clusters) wrt Gene location and AlnScore
#################################################################################
my $numberPerLocToPrint;
$numberPerLocToPrint=shift(@ARGV) if(@ARGV > 0);
my %locGroups=();
my %maxAlnScoreLoc=();
while(<stdin>) {
  if (! ($_ =~ m/^\#/)) {
		chomp;
		my @curF=split(/\s+/);
		### save in hash with key chr_Organism -> AlnScore -> ENSGfile_regionN
		if(@curF > 4) {
		 push(@{$locGroups{($curF[3] . "_" . $curF[4])}->{$curF[1]}->{($curF[2] . "_" . $curF[0])}}, [ @curF ]);
		 $maxAlnScoreLoc{($curF[3] . "_" . $curF[4])} = SynBlast::MyUtils::max($curF[1], $maxAlnScoreLoc{($curF[3] . "_" . $curF[4])});
	  }
	}
}
my %maxAlnSc=();
my @locs=keys %maxAlnScoreLoc;
my @scores=values %maxAlnScoreLoc;
for(my $ls=0; $ls < @locs; ++$ls) {
		push(@{$maxAlnSc{$scores[$ls]}}, $locs[$ls]);
}

foreach my $cSc (reverse sort {$a <=> $b} (keys %maxAlnSc)) {
  foreach my $cLoc (@{$maxAlnSc{$cSc}}) {
		#my $cLoc = $maxAlnSc{$cSc}->[$cLI];
		#last if(defined($numberPerLocToPrint) && (++$countr > $numberPerLocToPrint));
		
		#foreach my $cAlnSc (reverse sort {$a <=> $b} (keys %{$locGroups{$cLoc}})) {
		  my @cKeys=reverse sort {$a <=> $b} (keys %{$locGroups{$cLoc}});
			for(my $cLI=0; $cLI<SynBlast::MyUtils::min(scalar(@cKeys), $numberPerLocToPrint); ++$cLI) {
			   my $cAlnSc	= $cKeys[$cLI];
			   foreach my $cEnsgReg (keys %{$locGroups{$cLoc}->{$cAlnSc}}) {
				print #"${cSc}
					"${cLoc} ${cAlnSc} ${cEnsgReg}"; #\n";
				my ($cStart, $cEnd)=(undef, undef);
				foreach my $cF (@{$locGroups{$cLoc}->{$cAlnSc}->{$cEnsgReg}}) {
					#print join(" ", @{$cF}) . "\n";
					if(@{$cF} > 15) {
						#print $cF->[13] . " " . $cF->[14] . "\n";
						$cStart=SynBlast::MyUtils::min($cF->[13], $cStart);
					  $cEnd=SynBlast::MyUtils::max($cF->[14], $cEnd);
					 }
				}
				print " ${cStart} ${cEnd}" if(defined($cStart) && defined($cEnd));
				print "\n";
				
			}
		}
	}
	print "\n\n";
}
				
