#!/bin/bash
tblDir="./tblastn";
cutoff=50;
ovl=40;
orgDirs="_";    ### can be space separated list in quotes
qValues="3";
ensgFiles="ENSG"; ### .protein.info -prefix!
addP="";
addP2="";
#sel="mySelection";
sel="";
if [ ! "$1" == "" ] ; then
ensgFiles="$1";
else
echo -n -e "Usage (defaults in []): $0 infoFileFilter[${ensgFiles}] (orgDirs[${orgDirs}]) (minQN[${qValues}]) (sCutOff[${cutoff}]) (addParam1) (addParam2) (dirForCombinedOrgs)\n";
exit 1;
fi;
if [ ! "$2" == "" ] ; then
orgDirs="$2";
#qValues="55\n45\n";
if [ ! "$3" == "" ] ; then
qValues="$3";
if [ ! "$4" == "" ] ; then
cutoff="$4";
if [ ! "$5" == "" ] ; then
addP="$5";
if [ ! "$6" == "" ] ; then
addP2="$6";
if [ ! "$7" == "" ] ; then
sel="$7";
fi;
fi;
fi;
fi;
fi;
fi;
##############
resultDir="syntenyAlns${cutoff}";
#
mySubD="${resultDir}";
for i in `echo -n -e "${mySubD}\n"`; do
if [ ! -d "${i}" ] ; then
mkdir "${i}";
fi;
done;
#
##echo -n -e "orgDirs=${orgDirs}, qValue=${qValues}, ensgFile=${ensgFiles}\n";
cd ${tblDir} || exit 1;
tblDir=`pwd`;
cd -;
orgLi="";
for myo in `echo -n -e "${orgDirs}"`; 
do
curOrgLi=`ls ${tblDir}/*${myo}*blastresult | perl -F'/' -ane 'print($F[-1]);' | perl -F'\.' -ane 'print($F[-2], "\n");'`;
orgLi=`echo -n -e "${orgLi}\n${curOrgLi}"`;
done;
orgList=`echo "${orgLi}" | perl -e 'while(<>) {chomp; $Org{$_}++; } foreach $a (keys %Org) { print($a, "\n");} '`;
##
####################################################
if [ ! "${sel}" == "" ] ; then
##
### combine all selected organism's syntenyRegions into one combined SyntenyAlignment job
##
for j in `ls -d ${ensgFiles}*.protein.syntenyRegions/`; do 
echo $j >&2; 
myENSG=`echo $j | perl -ane 'print("", substr(\$F[0], 0, -24), "\n");'`;
echo ${myENSG}; 
###
for qv in `echo -n -e ${qValues}`; do
selDir="${sel}_ov${ovl}_minQN${qv}";
###
### create list of syntenyRegions for selection of Orgs...
synLi="";
for myorg in `echo ${orgList}`; do
curSynLi=`ls ${j}*${myorg}.*.minQN${qv}.*.blastresult`;
synLi=`echo -n -e "${synLi} ${curSynLi}"`;
done;
myArgLine="-m=-1000 -t=90 -g=-10:-2 -i=${myENSG}.protein.info -c=${cutoff} -o=${ovl} ${addP} ${addP2}";
myArgInter="-txtFile=${resultDir}/${selDir}/${myENSG}.alns.txt -html=${resultDir}/${selDir}/${myENSG}.html";
for dd in `echo -n -e "${resultDir}/${selDir}\n"`; do
if [ ! -d "${dd}" ] ; then
mkdir "${dd}";
fi;
done;
echo "creating ${selDir}/${myENSG} combined results...";
doSyntenyAlignment.pl ${myArgInter} ${myArgLine} ${synLi} > ${resultDir}/${selDir}/${myENSG}.txt 2> ${resultDir}/${selDir}/${myENSG}.err.log || rm -v ${resultDir}/${selDir}/${myENSG}.txt;
done; ## qv
done; ### j in syntenyRegions
##############################
else 
### each organism of selection is saved in separate directories/files
for myorg in `echo ${orgList}`; do
echo $myorg >&2; 
#####
for j in `ls -d ${ensgFiles}*.protein.syntenyRegions/`; do 
echo $j >&2; 
#myENSG=`echo $j | perl -F'\.' -ane 'print(\$F[0], "\n");'`;
myENSG=`echo $j | perl -ane 'print("", substr(\$F[0], 0, -24), "\n");'`;
echo ${myENSG}; 
###
for qv in `echo -n -e ${qValues}`; do
###echo "#log file for sub selection q${qv}" >> q${qv}.errorlog.txt;
resPrefixI="${resultDir}/${myorg}/${myENSG}.${myorg}.ov${ovl}.QN${qv}";
myArgLine="-m=-1000 -t=90 -g=-10:-2 -i=${myENSG}.protein.info -c=${cutoff} -o=${ovl} ${addP} ${addP2}";
myArgInter="-txtFile=${resPrefixI}.alns.txt -html=${resPrefixI}.html";
##
for dd in `echo -n -e "${resultDir}/${myorg}\n"`; do
if [ ! -d "${dd}" ] ; then
mkdir "${dd}";
fi;
done;
echo "creating ${myENSG} results for ${myorg}...";
doSyntenyAlignment.pl ${myArgInter} ${myArgLine} ${j}*${myorg}.*.minQN${qv}.*.blastresult > ${resPrefixI}.txt 2> ${resPrefixI}.err.log || rm -v ${resPrefixI}.txt;
done; ## gv
done; ## ensg
done; ### myorg
fi; ### if sel != ""
exit 0;
