#!/usr/bin/env perl

use strict;

die "Usage: separateBlastResults.pl inputfile resultSuffix [sepIdx outdir]\n" unless(@ARGV > 1);
my ($inputfile, $resultSuffix, $sepIdx, $outdir) = @ARGV;

$sepIdx=0 if(! defined($sepIdx)); # use per default queryName to separate on
$outdir="./" if(! defined($outdir));
open(INP, '<', $inputfile) or die "Error: Could not open ${inputfile}: $! !\n";
mkdir $outdir unless(-d $outdir); 

my %separateHits=();
while(<INP>) {
  if ($_ =~ m/^[^\#]/) {
    chomp;
    my @curF=split(/\s+/);
    ($sepIdx < @curF) or die "Error: separation-index out of range!\n";
    push(@{$separateHits{$curF[$sepIdx]}}, $_);
  }
}
close(INP);

foreach my $curQ (keys %separateHits) {
  my $outfile= "${outdir}/${curQ}.${resultSuffix}";
  print STDERR "writing file ${outfile}...\n";
  
  open(OUTF, '>', $outfile) or die "Error: Could not create ${outfile}: $! !\n";
  print OUTF "# created by separateBlastResults.pl through filtering on idx position ${sepIdx} of blastresult file ${inputfile}...\n";
  foreach my $curE (@{$separateHits{$curQ}}) {
    print OUTF $curE . "\n";
  }
  close(OUTF);
}
print STDERR "..finished!\n";
exit 0;


